# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define	section		free

Name:		jrms
Summary:	JRMS - Java Reliable Multicast Service
Url:		http://www.experimentalstuff.com/Technologies/JRMS/
Version:	1.1
Release:	2jpp
Epoch:		0
License:	BSD-style
Group:		Development/Libraries/Java
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	jrms1.1.jar
Source1:	jrms-build.xml
Patch0:		jrms-1.1-inria.util.Utilities.patch
Patch1:		jrms-1.1-KeyProtector.patch
Patch2:		jrms-1.1-DataSender.patch
BuildRequires:	java-devel >= 0:1.4
%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
The Java Reliable Multicast Service[tm] is a set of libraries 
and services for building multicast applications. It enables 
building applications that multicast data from senders to 
receivers. The JRM Service supports multiple reliable multicast 
transports through a federated interface, which provides 
isolation to applications, and a service provider interface 
underneath to allow third parties to plug in other reliable 
multicast transport implementations. 

The JRM Service can be used by information distribution 
applications as the transport for delivery of content to very 
large constituencies. As compared to unicast protocols (i.e., 
HTTP), reliable multicast enables broadcasting to groups of 
receivers, ensuring bandwidth conservation and timely delivery. 
TRAM, a reliable multicast transport protocol developed along 
with the JRM Service, is designed for high scalability, targeted 
at very large numbers of receivers. The JRM Service also includes 
new services for multicast address allocation and management of 
channels, as well as a dynamic filtering mechanism that uses Java 
software classes which are pushed into the network for the purpose 
of interpreting the data downstream from the server.


%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -c -n %{name}-%{version}
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
    mv $f $f.no
done
rm -f jrms1.1/src/reliable/transport/tram/TRAMCongestion.java
rm -f jrms1.1/src/reliable/transport/tram/TRAMCongestionPacket.java
rm -f jrms1.1/src/reliable/transport/tram/TRAMCongestionPacketEvent.java
rm -f jrms1.1/src/reliable/transport/tram/TRAMCongestionPacketListener.java

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build
cd jrms1.1
cp %{SOURCE1} build.xml
ant jar javadoc

%install
# jars
cd jrms1.1
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 %{name}-%{version}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root)
%doc jrms1.1/*.TXT jrms1.1/*.html
%{_javadir}/*
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Wed Oct 18 2006 Ralph Apel <r.apel at r-apel.de> 0:1.1-2jpp
- First JPP-1.7 release
- Switch from make to ant
- Add gcj_support option
- Add javadoc post/postun Requires

* Tue Mar 01 2005 Ralph Apel <r.apel at r-apel.de> 0:1.1-1jpp
- First release

